#include <stdio.h>
#include <stdlib.h>
#include <math.h>

//entropia
void entropia(int ** matriz, FILE * entropia_out, int w, int h)
{	
	int minimo = 0;
	int i,j;
	for(i=0;i<h;i++){
		for(j=0;j<w;j++){
			minimo = matriz[i][j]<minimo?matriz[i][j]:minimo;
			//~ minimo = min(minimo,matriz[i][j]);
		}
	}
	int acum[300000] = {0};
	for(i=0;i<h;i++){
		for(j=0;j<w;j++){
			acum[matriz[i][j]-minimo]++;
		}
	}

	double entropia = 0.0;
	for(i=0;i<300000;i++){
		if(!acum[i])continue;
		double prob = (double)acum[i]/(double)(h*w);
		entropia -= prob*log2(prob);
	}

	//~ printf(".10lf\n",entropia);
	fprintf(entropia_out, "%.10lf \n", entropia);
	
}


void psnr(int ** matriz1, int ** matriz2, FILE * psnr_out, int w, int h)
{
	//PSNR
	double mse = 0.0;
	int i,j;
	for(i=0;i<h;i++){
		for(j=0;j<w;j++){
			mse += (matriz1[i][j]-matriz2[i][j])*(matriz1[i][j]-matriz2[i][j]);
		}
	}

	mse /= (h*w);
	double psnr = 10*log10((255*255)/mse);
	fprintf(psnr_out, "%.10lf \n", psnr);
}
