BITS 32

%define imagen [ebp + 8]
%define i [ebp + 12]
%define j [ebp + 16]
%define width [ebp + 20]		; el ancho vendra expresado en bytes.
%define high [ebp + 24]
%define temp ebp - 40 ; 40 = 8 + 32 reservo el espacio para toooooda la fila



cos_f0_1: dd 1.0, 1.0, 1.0, 1.0
cos_f0_2: dd 1.0, 1.0, 1.0, 1.0
cos_f1_1: dd 0.980785, 0.831470, 0.555570, 0.195090
cos_f1_2: dd -0.195090, -0.555570, -0.831470, -0.980785
cos_f2_1: dd 0.923880, 0.382683, -0.382683, -0.923880
cos_f2_2: dd -0.923880, -0.382683, 0.382683, 0.923880
cos_f3_1: dd 0.831470, -0.195090, -0.980785, -0.555570
cos_f3_2: dd 0.555570, 0.980785, 0.195090, -0.831470
cos_f4_1: dd 0.707107, -0.707107, -0.707107, 0.707107 
cos_f4_2: dd 0.707107, -0.707107, -0.707107, 0.707107
cos_f5_1: dd 0,555570, -0.980785, 0.195090, 0.831470
cos_f5_2: dd -0.831470, -0.195090, 0.980785, -0.555570
cos_f6_1: dd 0.382683, -0.923880, 0.923880, -0.382683
cos_f6_2: dd -0.382683, 0.923880, -0.923880, 0.382683
cos_f7_1: dd 0.195090, -0.555570, 0.831470, -0.980785
cos_f7_2: dd 0.980785, -0.831470, 0.555570, -0.195090


global dct_asm

section .text

dct_asm:
	push ebp
	mov ebp, esp
	push edi
	push esi
	push ebx
	
	sub esp, 32 ; ahora esp apunta al comienzo de mi variable temp
	
	mov esi, imagen
	mov ebx, i
	mov edi, j
	xor ecx, ecx  ;ecx contiene a
	
	.ciclo_fila_dct:
	
		xor edx, edx ;edx contiene a b
		cmp ecx, 8
		jne .ciclo_fila
		jmp .ciclo_columnas_dct
		
	.ciclo_fila: ;me fijo en que fila estoy para usar los cosenos correctos 
		cmp edx, 0
		je .caso_f0
		cmp edx, 1
		je .caso_f1
		cmp edx, 2
		je .caso_f2		
		cmp edx, 3
		je .caso_f3		
		cmp edx, 4
		je .caso_f4
		cmp edx, 5
		je .caso_f5
		cmp edx, 6
		je .caso_f6
		cmp edx, 7
		je .caso_f7
		
		.caso_f0:
			mov xmm0, cos_f0_1
			mov xmm1, cos_f0_2 	
			mov eax, ebx
			add eax, ecx
			mul eax, width
			;mul edi, 4
			add eax, imagen
			movdqu xmm2, [eax + edi*4] ; ((i+a)* (ancho*4)+(j + c)*4)aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
			cvtdq2ps xmm2, xmm2
			add eax, 16		;me estoy salteando los primero 4 elementos que acabo de leer
			movdqu xmm3, [eax + edi*4] ;aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
			cvtdq2ps xmm3, xmm3
			pmulld xmm0, xmm2
			pmulld xmm1, xmm3
			haddps xmm0, xmm1
			xor xmm1, xmm1
			haddps xmm0, xmm1
			xor xmm1, xmm1
			haddps xmm0, xmm1
			;dejo toda la suma en 32 bits en el primer bloque de xmm0
			;voy a guardar en memoria el valor de la fila para iterar en columnas xmm0 = [valor, 0, 0, 0]
			mov DWORD [temp + 4*0], xmm0 ;al final de todo pasamos a int luego de columnas CVTPS2DQ
			
		.caso_f1:
			mov xmm0, cos_f1_1
			mov xmm1, cos_f1_2
			mov xmm2, imagen ;aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
			mov xmm3, imagen ;aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
			pmulld xmm0, xmm2
			pmulld xmm1, xmm3
			haddps xmm0, xmm1
			xor xmm1, xmm1
			haddps xmm0, xmm1
			xor xmm1, xmm1
			haddps xmm0, xmm1
			;dejo toda la suma en 32 bits en el primer bloque de xmm0
			mov DWORD [temp + 4*1], xmm0
			
		.caso_f2:
			mov xmm0, cos_f2_1
			mov xmm1, cos_f2_2
			mov xmm2, imagen ;aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
			mov xmm3, imagen ;aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
			pmulld xmm0, xmm2
			pmulld xmm1, xmm3
			haddps xmm0, xmm1
			xor xmm1, xmm1
			haddps xmm0, xmm1
			xor xmm1, xmm1
			haddps xmm0, xmm1
			;dejo toda la suma en 32 bits en el primer bloque de xmm0
			mov DWORD [temp + 4*2], xmm0
		.caso_f3:	
			mov xmm0, cos_f3_1
			mov xmm1, cos_f3_2
			mov xmm2, imagen ;aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
			mov xmm3, imagen ;aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
			pmulld xmm0, xmm2
			pmulld xmm1, xmm3
			haddps xmm0, xmm1
			xor xmm1, xmm1
			haddps xmm0, xmm1
			xor xmm1, xmm1
			haddps xmm0, xmm1
			;dejo toda la suma en 32 bits en el primer bloque de xmm0
			
		.caso_f4:	
			mov xmm0, cos_f4_1
			mov xmm1, cos_f4_2
			mov xmm2, imagen ;aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
			mov xmm3, imagen ;aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
			pmulld xmm0, xmm2
			pmulld xmm1, xmm3
			haddps xmm0, xmm1
			xor xmm1, xmm1
			haddps xmm0, xmm1
			xor xmm1, xmm1
			haddps xmm0, xmm1
			;dejo toda la suma en 32 bits en el primer bloque de xmm0
			
		.caso_f5:	
			mov xmm0, cos_f5_1
			mov xmm1, cos_f5_2
			mov xmm2, imagen ;aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
			mov xmm3, imagen ;aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
			pmulld xmm0, xmm2
			pmulld xmm1, xmm3
			haddps xmm0, xmm1
			xor xmm1, xmm1
			haddps xmm0, xmm1
			xor xmm1, xmm1
			haddps xmm0, xmm1
			;dejo toda la suma en 32 bits en el primer bloque de xmm0
			
		.caso_f6:	
			mov xmm0, cos_f6_1
			mov xmm1, cos_f6_2
			mov xmm2, imagen ;aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
			mov xmm3, imagen ;aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
			pmulld xmm0, xmm2
			pmulld xmm1, xmm3
			haddps xmm0, xmm1
			xor xmm1, xmm1
			haddps xmm0, xmm1
			xor xmm1, xmm1
			haddps xmm0, xmm1
			;dejo toda la suma en 32 bits en el primer bloque de xmm0
			
		.caso_f7:	
			mov xmm0, cos_f7_1
			mov xmm1, cos_f7_2
			mov xmm2, imagen ;aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
			mov xmm3, imagen ;aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
			pmulld xmm0, xmm2
			pmulld xmm1, xmm3
			haddps xmm0, xmm1
			xor xmm1, xmm1
			haddps xmm0, xmm1
			xor xmm1, xmm1
			haddps xmm0, xmm1
			;dejo toda la suma en 32 bits en el primer bloque de xmm0
				
	.ciclo_columnas_dct:


.fin:	
	pop ebx
	pop esi
	pop edi
	pop ebp
	ret
