#ifndef huffman_h

#include "list.h"

#define huffman_h
#define VALIDO 1
#define INVALIDO 0
#define DERECHA 0
#define IZQUIERDA 1

/*este struct lo vamos a utilizar al principio de la descomprecion de los bloques*/       
#define TAM_HEADER_OC2 sizeof(oc2_header_t)

typedef struct{
		unsigned int offset_first_frame_header;
		int cant_frames;
		int fourcc;
		double fps;
		int width; 
		int height;
		}__attribute__ (( __packed__ )) oc2_main_header_t;

typedef struct{
        unsigned int offset_header;
        unsigned int tam_header;
        unsigned int offset_tabla; 
        unsigned int long_codificacion;
        unsigned int cant_codigos; 
        unsigned int offset_codificacion;
        } __attribute__ (( __packed__ )) oc2_header_t;
        
oc2_header_t * leer_info_oc2 (FILE * compress_image);
oc2_main_header_t * read_main_header_oc2 (FILE * oc2_header);
void write_info_oc2 (FILE * image_out, oc2_header_t * oc2);
void mostrar_oc2 (oc2_header_t * oc2);


//Funciones para la compresion huffman
nodo_arbol_t * crear_arbol (char simbolo, unsigned int apariciones, unsigned int valido,
	void* padre, void* izquierda, void* derecha);
nodo_arbol_t * crear_arbol_default ();
void huffman(int ** i_matrix, int w, int h);
nodo_arbol_t * generar_arbol_huffman(nodo_lista_ab * tabla_codigos);
nodo_lista_c * generar_lista_codigos(nodo_lista_ab * lista_ab);
nodo_lista_ab * generar_tabla_apariciones(int ** i_matrix, int width, int high);
//~ nodo_lista_t *  insertar_ordenado(nodo_lista_t * tabla_codigos, nodo_arbol_t * nodo_arbol_n);
int generar_codigos(nodo_lista_c * lista, int * longitud_codificado);
int generar_codigo_aux(nodo_lista_c * nodo, int * longitud_codificado);
void mostrarArbolAux ( nodo_arbol_t *raiz, int nivel );
void alinear ( char ch, int n );
void mostrar_tabla(int * t);
//~ void mostrar_codigos (codigo_t * tabla_codif[500]);
unsigned int * comprimir_buffer (int ** i_matrix, int width, int high, nodo_lista_c * lista, int long_codificado);

void imprimir_archivo_codigos(nodo_lista_c * nodo);
//Funciones para la descompresion huffman

nodo_arbol_t * generar_arbol_descomprecion (nodo_lista_c * tabla_cod, int cant_codigos);
nodo_lista_c * leer_codigos (FILE * compress_image, unsigned int cant_codigos, unsigned int offset_tabla);
void descomprimir_buffer(int long_codificacion, unsigned int * codif, int ** i_matrix, int width, int high, nodo_arbol_t * ptr_arbol_huff);

void write_header(int long_codificacion, int tam_header_bmp, nodo_lista_c * tabla_codif, FILE* image_in, FILE* image_out);
void write_header_video(int long_codificacion, nodo_lista_c * tabla_codif, FILE* image_out);
void write_buffer(unsigned int * buffer, int m, FILE * image_out, int indice);

#endif
