//      main.c
//      
//      Copyright 2013 agus <agus@agus-laptop>
//      
//      This program is free software; you can redistribute it and/or modify
//      it under the terms of the GNU General Public License as published by
//      the Free Software Foundation; either version 2 of the License, or
//      (at your option) any later version.
//      
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//      
//      You should have received a copy of the GNU General Public License
//      along with this program; if not, write to the Free Software
//      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
//      MA 02110-1301, USA.


#include <stdio.h>
#include <stdlib.h>
#include "functions.h"
#include "test_jpeg.h"
#include "test_huff.h"
#include "huffman.h"

#define HIGH 512
#define WIDTH 512


int main2(int argc, char** argv)
{
	printf("Running tests\n");
	FILE *image_in;
	FILE *image_out;
	image_in = fopen("lena_in.bmp", "rb+");
	image_out = fopen("lena_out.bmp", "rb+");
	int size = -1;
	int begin = -1;
	
	// ########## OPENING FILE ########## 
	
    if(image_in == NULL)
    {
        printf("Error in opening the image\n");
        fclose(image_in);
        return(1);
    } 

    printf("Successfully opened the image file\n");
	int **i_matrix;
    int i;
    i_matrix = (int**) malloc (HIGH * sizeof (int*));    
    for (i = 0; i < HIGH; i++)
        i_matrix[i] = (int*) malloc (WIDTH * sizeof (int)); 

	// ** Leer datos e imagen ****
	fseek(image_in, 2, SEEK_SET);
	fread(&size, 4, 1, image_in);
	fseek(image_in, 10, SEEK_SET);
	fread(&begin, 4, 1, image_in);
	
	
	//~ printf("File size %i B\n", size);
	//~ printf("Image begin %i\n", begin);
	//~ printf("Image size %i B\n", size - begin);
	int tam_header_bmp = begin-1;
	read_image(image_in, i_matrix, WIDTH, HIGH, begin, size);
	
	//print_matrix(i_matrix, WIDTH, HIGH);
	//************************************

	// ########## END OPENING FILE ########## 
	int res;	
	
	// ########## TEST reducing he image ########## 
	
	//~ test_reduce_image(i_matrix, WIDTH, HIGH);
	
	// ########## END TEST SUBSTRACT 128 ########## 
	
	
	// ########## TEST SUBSTRACT 128 ########## 
	
	test_substract_128(i_matrix, WIDTH, HIGH);
	
	// ########## END TEST SUBSTRACT 128 ########## 
	//~ 
	// ########## TEST RANGE ########## 
	
	//~ test_range128(i_matrix, WIDTH, HIGH);
	
	// ########## END TEST RANGE ########## 
	//~ 
	// ########## TEST DCT ########## 
	
	printf("test_dct\n");
	res = test_dct(i_matrix, WIDTH, HIGH);
	if (res !=0 )
	{
		printf("\n test_dct no anduvo \n");
	} else printf("test_dct...	OK\n");
	
	// ########## END TEST DCT ########## 
	//~ 
	// ########## TEST QUANTIZATION ########## 
	
	//~ printf("test_quant \n");
	//~ res = test_quant(i_matrix, WIDTH, HIGH);
	//~ if (res !=0 )
	//~ {
		//~ printf("\n test_quant no anduvo \n");
	//~ } else printf("test_quant...	OK\n");
	//~ 
	
	// ########## END TEST QUANTIZATION ########## 
	
	// ########## TEST THRESHOLD ########## 
	
	//~ printf("test_thresh \n");
	//~ res = test_thresh(i_matrix, WIDTH, HIGH);
	//~ if (res !=0 )
	//~ {
		//~ printf("\n test_thresh no anduvo \n");
	//~ } else printf("	test_thresh... OK\n");
	
	
	// ########## END TEST THRESHOLD ########## 	
	
	// ########## TEST COMPRESION Y DESCOMPRESION HUFFMAN ########## 
	// print_matrix(i_matrix, WIDTH, HIGH);
	//~ test_add_128(i_matrix, WIDTH, HIGH);
	// print_matrix(i_matrix, WIDTH, HIGH);
	res = test_compr_huff_im(i_matrix, WIDTH, HIGH, tam_header_bmp, image_in, image_out);
	if(res != 0)
	{
		printf("ERROR \n");
	}
	
	//~ res = test_descompr_huff_im(i_matrix, WIDTH, HIGH);
	//~ if(res != 0)
	//~ {
		//~ printf("ERROR \n");
	//~ }
	//~ test_substract_128(i_matrix, WIDTH, HIGH);
	
	// ########## END TEST COMPRESION Y DESCOMPRESION HUFFMAN ########## 	
	
	

	
	// ########## TEST MUL QUANTIZATION ########## 
	
	//~ printf("test_m_quant \n");
	//~ res = test_m_quant(i_matrix, WIDTH, HIGH);
	//~ if (res !=0 )
	//~ {
		//~ printf("\n test_m_quant no anduvo \n");
	//~ } else printf("test_m_quant	OK\n");
	
	
	// ########## END TEST MUL QUANTIZATION ########## 
	
	// ########## TEST IDCT ########## 
	
	//~ printf("test_idct\n");
	//~ res = test_idct(i_matrix, WIDTH, HIGH);
	//~ if (res !=0 )
	//~ {
		//~ printf("\n test_idct no anduvo \n");
	//~ } else printf("test_idct... 	OK\n");
	
	// ########## END TEST IDCT ########## 
		
	// ########## TEST ADD 128 ########## 
	
	//~ test_add_128(i_matrix, WIDTH, HIGH);
	
	// ########## END TEST ADD 128 ########## 
		
		
	//~ test_range256(i_matrix, WIDTH, HIGH);
	// ########## TEST WRITE ########## 

	//~ write_image(image_out, i_matrix, WIDTH, HIGH, begin, size);
	
	// ########## TEST END WRITE ########## 
	
	
	fclose(image_in);
	fclose(image_out);
	
	//~ int ** matrix;
	//~ matrix = armar_matriz_prueba(8, 8);
	//~ test_compr_huff(matrix, 8, 8);
	
	return 0;
}
